/* ---------------------------------------------------------
 *  find_I2C.c -                  
 * ---------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/i2c-dev.h>

int file;

void MCP23008_write(unsigned char reg, unsigned char value){
    unsigned char data[2];
    data[0] = reg;
    data[1] = value;
    if ( write(file,data,2) != 2) {
        printf("%d ",write(file,data,2));
        printf("MCP23008_write failed\n");
        exit(1);
    }
}

unsigned char MCP23008_read(unsigned char reg){
    unsigned char data[1];
    unsigned char result[1];
    data[0] = reg;
    if ( write(file,data,1) != 1) {
        printf("MCP23008_read failed\n");
        exit(1);
    }
    read(file,result,1);
    return result[0];
}

unsigned int scan(void){
	unsigned int addr;
    unsigned char data[1];
    unsigned char result[1];
	unsigned int rc = -1;
	
    	for(addr = 0x00;addr <0x80; addr++){
		if ((ioctl(file,I2C_SLAVE,addr)) < 0){
          		printf("ioctl failed, ");
            	printf("addr=0x%02x\n",addr);
            	exit(1);
    	} else {
			data[0] = addr;
			if(write(file,data,1) == 1){
    			read(file,result,1);
	    		printf("\nI2C slave device found at address 0x%02x \n", addr);
				rc = addr;
			}
    	}
	}
	return rc;
}


unsigned char MCP23008(unsigned char reg){
    unsigned char data[1];
    unsigned char result[1];
    data[0] = reg;
    if ( write(file,data,1) != 1) {
        printf("MCP23008_read failed\n");
		return result[0];
    }
    read(file,result,1);
    return result[0];
}


int main(int argc, char *argv[]) {

    if ((file = open("/dev/i2c-0",O_RDWR)) < 0) {
        printf("%s: ",argv[0]);
        printf("failed to open /dev/i2c-0, err=%d\n",file);
        exit(1);
    }

    scan();

	return(0);
}





